setMilestone(MS_LEFT_SEASIDE_BY_BOAT, false)
setMilestone(MS_LEFT_EAST_BY_BOAT, false)

music = "burned_village.ogg"

talked_to_captain = false
captain_moved = false

local loops = 0
local tiggy_scene_started = false

function end_captain_walk()
	captain_moved = true
	descriptifyPlayer()
end

function party_appear()
	local px, py = getObjectPosition(0)
	faelon = Object:new{x=px, y=py, anim_set="Faelon", person=true}
	mel = Object:new{x=px, y=py, anim_set="Mel", person=true}
	tig = Object:new{x=px, y=py, anim_set="Tiggy", person=true}
	setObjectSolid(faelon.id, false)
	setObjectSolid(mel.id, false)
	setObjectSolid(tig.id, false)
	faelon.scripted_events = {
		{ event_type=EVENT_WALK, dest_x=px-1, dest_y=py },
		{ event_type=EVENT_LOOK, direction=DIRECTION_NORTH },
		{ event_type=EVENT_SYNC, who=eny, number=5 },
		{ event_type=EVENT_WALK, dest_x=px, dest_y=py },
		{ event_type=EVENT_SYNC, who=eny, number=7 },
	}
	mel.scripted_events = {
		{ event_type=EVENT_WALK, dest_x=px+1, dest_y=py },
		{ event_type=EVENT_LOOK, direction=DIRECTION_NORTH },
		{ event_type=EVENT_SYNC, who=eny, number=5 },
		{ event_type=EVENT_WALK, dest_x=px, dest_y=py },
		{ event_type=EVENT_SYNC, who=eny, number=7 },
	}
	tig.scripted_events = {
		{ event_type=EVENT_WALK, dest_x=px, dest_y=py-1 },
		{ event_type=EVENT_LOOK, direction=DIRECTION_SOUTH },
		{ event_type=EVENT_SYNC, who=eny, number=5 },
		{ event_type=EVENT_WALK, dest_x=px, dest_y=py },
		{ event_type=EVENT_SYNC, who=eny, number=7 },
	}
end

function done_tiggy_scene()
	removeObject(faelon.id)
	removeObject(mel.id)
	removeObject(tig.id)
	descriptifyPlayer()
	setMilestone(MS_TIGGY_SEASIDE_SCENE, true)
	tiggy_scene_started = false
	eny, faelon, mel, tig = nil, nil, nil, nil
	setObjectSolid(0, true)
end

function start()
	if (not getMilestone(MS_SEASIDE_REPAIRED)) then
		addSmoke(10, 6)
		addSmoke(27, 4);
		addSmoke(28, 26)
		informant = Object:new{x=20, y=20, anim_set="Seaside_informant", person=true, move_type=MOVE_WANDER}

		chest0 = Chest:new{x=34, y=23, anim_set="chest", milestone=MS_BURNED_SEASIDE_CHEST_0, index=ITEM_VITAL1}
		chest1 = Chest:new{x=35, y=23, anim_set="chest", milestone=MS_BURNED_SEASIDE_CHEST_1, index=ITEM_HEAL}
		chest2 = Chest:new{x=36, y=23, anim_set="chest", milestone=MS_BURNED_SEASIDE_CHEST_2, index=ITEM_ELIXIR}

		libPortal = Portal:new{x=28, y=6}
	end

	shopDoor = Door:new{x=36, y=8, anim_set="home_door"}
	shopPortal = Portal:new{x=36, y=8}

	captain = Object:new{x=52, y=14, anim_set="Captain", person=true}
	mate = Object:new{x=51, y=14, anim_set="Mate", person=true}
end

function stop()
end

function update(step)
	if (loops > 0) then
		if (not getMilestone(MS_TIGGY_SEASIDE_SCENE) and getMilestone(MS_BEAT_RIDER) and not tiggy_scene_started) then
			stopObject(0)
			scriptifyPlayer()
			local px, py = getObjectPosition(0)
			eny = Object:new{id=0, x=px, y=py}
			eny.scripted_events = {
				{ event_type=EVENT_WALK, dest_x=px, dest_y=py-4 },
				{ event_type=EVENT_CUSTOM, callback=party_appear },
				{ event_type=EVENT_REST, delay=1000 },
				{ event_type=EVENT_SPEAK, text="Tiggy: Oh my... I... uh... I did this?\nEny: No, this staff did this, it only used you as a vessel!\nTiggy: We must destroy this staff... perhaps the wise King would know how?\nFaelon: Indeed, let's head to the East.\n" },
				{ event_type=EVENT_WAIT_FOR_SPEECH },
				{ event_type=EVENT_REST, delay=1000 },
				{ event_type=EVENT_CUSTOM, callback=done_tiggy_scene },
			}
			tiggy_scene_started = true
		end
	else
		loops = loops + 1
	end

	if (tiggy_scene_started) then
		if (not (faelon == nil)) then
			faelon:update(step)
			mel:update(step)
			tig:update(step)
		end
		eny:update(step)
	end

	px, py = getObjectPosition(0)
	if (py >= 34) then
		stopObject(0)
		doMap("seaside")
	end
	
	if (not getMilestone(MS_SEASIDE_REPAIRED)) then
		informant:move(step)
	
		libPortal:update()

		if (libPortal.go_time) then
			transitionOut()
			setObjectPosition(0, 13, 3)
			setObjectDirection(0, DIRECTION_SOUTH)
			startArea("library_downstairs")
			clearBuffer()
			updateArea()
			drawArea()
			transitionIn()
		end
	end

	if (talked_to_captain and not captain_moved) then
		captain:update(step)
		mate:update(step)
	end

	shopPortal:update()

	if (shopDoor.isOpen and shopPortal.go_time) then
		transitionOut()
		setObjectPosition(0, 4, 9)
		setObjectDirection(0, DIRECTION_NORTH)
		startArea("seaside_shop")
		clearBuffer()
		updateArea()
		drawArea()
		transitionIn()
	end
end

function activate(activator, activated)
	if (not getMilestone(MS_SEASIDE_REPAIRED)) then
		if (activated == informant.id) then
			doDialogue("When the fires started everyone went south.\n", true)
			if (not getMilestone(MS_GOT_BADGE) and getMilestone(MS_UNDERGROUND_CHEST_2)) then
				doDialogue("Say, is that a letter?\nThat looks like my father's writing. I'll give you this badge for it?\n", true)
				slot = findUnfullInventorySlot(ITEM_LETTER)
				setInventory(slot, ITEM_BADGE, 1)
				loadPlayDestroy("chest.ogg")
				setMilestone(MS_GOT_BADGE, true)
			end
		elseif (activated == chest0.id) then
			chest0:activate()
		elseif (activated == chest1.id) then
			chest1:activate()
		elseif (activated == chest2.id) then
			chest2:activate()
		end
	end

	if (activated == captain.id) then
		if (getMilestone(MS_RIOS_JOINED)) then
			if (not talked_to_captain) then
				doDialogue("Captain: You want to board the ship? Aye, we set sail as soon as you're ready!\n", true)
				scriptifyPlayer()
				captain.scripted_events = {
					{event_type=EVENT_WALK, dest_x=52, dest_y=12},
					{event_type=EVENT_WALK, dest_x=58, dest_y=12},
					{event_type=EVENT_WALK, dest_x=58, dest_y=9},
					{event_type=EVENT_LOOK, direction=DIRECTION_EAST},
				}
				mate.scripted_events = {
					{event_type=EVENT_SYNC, who=captain, number=1},
					{event_type=EVENT_WALK, dest_x=51, dest_y=12},
					{event_type=EVENT_WALK, dest_x=58, dest_y=12},
					{event_type=EVENT_WALK, dest_x=58, dest_y=10},
					{event_type=EVENT_LOOK, direction=DIRECTION_EAST},
					{event_type=EVENT_CUSTOM, callback=end_captain_walk},
				}
				talked_to_captain = true
			elseif (captain_moved) then
				setMilestone(MS_TALKED_TO_CAPTAIN, true)
				setMilestone(MS_LEFT_SEASIDE_BY_BOAT, true)
				doDialogue("Captain: Alright then, off we go!\n", true)
				doMap("seaside")
			end
		else
			doDialogue("Captain: We don't sail without a holy man... rules of the sea!\n")
		end
	elseif (activated == mate.id) then
		doDialogue("Mate: G'day! ...\n")
	end
end

function collide(id1, id2)
	if (id1 == shopDoor.id or id2 == shopDoor.id) then
		shopDoor:open()
	end
end

